      program average
      implicit none
      integer :: numlines
      integer :: iostatus
      real :: run_sum
      real :: x 

      open(unit = 11, file = 'numbers.txt')

      ! initialize running sum and number of lines to 0

      run_sum = 0.0
      numlines = 0

      do
         read(11, *, iostat=iostatus) x
         ! if read was successful
         if (iostatus == 0) then
            run_sum = run_sum + x
            numlines = numlines + 1
         ! if read failed
         else if (iostatus > 0) then
            print*, "Something is wrong with input...exiting..."
            ! STOP quits the program
            STOP
         ! if read found end of file
         else
            ! exit terminates the do loop
            EXIT
         end if
      end do
            

      close(11)
      run_sum = run_sum / real(numlines)
      open(unit = 91, file = 'out.txt')
      write(91, *) run_sum
      close(91)
      print*, run_sum

      end program average


