      program average
      implicit none
      integer :: i
      integer, parameter :: numlines = 10
      real :: run_sum
      real :: x 

      ! open the file for reading
      open(unit = 11, file = 'numbers.txt')
      
      ! initialize the running sum
      run_sum = 0.0
      
      ! read the number on each line into x, 
      ! add to the running sum
      do i = 1, numlines
         read(11, *) x
         run_sum = run_sum + x
      end do

      close(11)
      ! calculate average by dividing running sum by number of lines
      run_sum = run_sum / real(numlines)

      ! open a file for writing and write the average to it
      open(unit = 91, file = 'out.txt')
      write(91, *) run_sum
      close(91)
      print*, run_sum

      end program average
